package com.hcloud.microservice.goods.controller;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseController;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microservice.goods.facade.clients.GoodsProNormalManagerService;
import com.hcloud.microservice.goods.facade.forms.GoodsProNormalForm;
import com.hcloud.microservice.goods.service.GoodsProNormalService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author JYJ
 */
@RestController
@RequestMapping("/pro/normal")
public class GoodsProNormalManageController extends BaseController implements GoodsProNormalManagerService {

    @Autowired
    private GoodsProNormalService goodsProNormalService;

    /**
     * 分页查询流通信息
     *
     * @param goodsProNormalForm
     * @return
     */
    @PostMapping("/searchProNormalByPage")
    @Override
    public ResultVO searchProNormalByPage(@RequestBody GoodsProNormalForm goodsProNormalForm) {
        PageInfo pageInfo = goodsProNormalService.searchProNormalByPage(goodsProNormalForm);
        return success(pageInfo.getList(),pageInfo.getTotal());
    }

    /**
     * 保存流程通用信息
     *
     * @param goodsProNormalForm
     * @return
     */
    @PostMapping("/saveProNormal")
    @Override
    public ResultVO saveProNormal(@RequestBody GoodsProNormalForm goodsProNormalForm) {
        int i = goodsProNormalService.saveSelective(goodsProNormalForm);
        if (i>0){
            return success();
        }
        return failure();
    }

    /**
     * 更新流通通用信息
     *
     * @param goodsProNormalForm
     * @return
     */
    @PostMapping("/updateProNormal")
    @Override
    public ResultVO updateProNormal(@RequestBody GoodsProNormalForm goodsProNormalForm) {
        int i = goodsProNormalService.modifyByPrimaryKeySelective(goodsProNormalForm);
        if (i>0){
            return success();
        }
        return failure();
    }

    /**
     * 通过主键删除通用流通信息
     *
     * @param pk
     * @return
     */
    @GetMapping("/delProNormalByPK")
    @Override
    public ResultVO delProNormalByPK(@RequestParam("pk") String pk) {
        int i = goodsProNormalService.delByPrimaryKey(pk);
        if (i>0){
            return success();
        }
        return failure();
    }
}
