package com.hcloud.microservice.goods.controller;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseController;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microservice.goods.facade.clients.GoodsTracedUserManagerService;
import com.hcloud.microservice.goods.facade.forms.GoodsTracedUserForm;
import com.hcloud.microservice.goods.service.GoodsTracedUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author JYJ
 */
@RestController
@RequestMapping("/traced/user")
public class GoodsTracedUserManageController extends BaseController implements GoodsTracedUserManagerService {

    @Autowired
    private GoodsTracedUserService goodsTracedUserService;

    /**
     * 查询用户信息通过第三方编码
     *
     * @param code
     * @return
     */
    @PostMapping("searchByCode")
    @Override
    public ResultVO searchTracedUserByCode(@RequestBody GoodsTracedUserForm tracedUserForm) {
        GoodsTracedUserForm form = goodsTracedUserService.searchTracedUserByCode(tracedUserForm.getTracedThirdCode(),tracedUserForm.getTracedUserOpenid());
        return success(form);
    }

    /**
     * 保存用户信息
     *
     * @param tracedUserForm
     * @return
     */
    @PostMapping("saveTracedUser")
    @Override
    public ResultVO saveTracedUser(@RequestBody GoodsTracedUserForm tracedUserForm) {
        int i = goodsTracedUserService.saveSelective(tracedUserForm);
        if(i>0){
            return success();
        }
        return failure();
    }

    /**
     * 更新用户信息
     *
     * @param tracedUserForm
     * @return
     */
    @PostMapping("updateTracedUser")
    @Override
    public ResultVO updateTracedUser(@RequestBody GoodsTracedUserForm tracedUserForm) {
        int i = goodsTracedUserService.modifyByPrimaryKeySelective(tracedUserForm);
        if(i>0){
            return success();
        }
        return failure();
    }

    /**
     * 分页查询溯源用户信息
     *
     * @param tracedUserForm
     * @return
     */
    @PostMapping("/searchTracedUserByPage")
    @Override
    public ResultVO searchTracedUserByPage(@RequestBody GoodsTracedUserForm tracedUserForm) {
        PageInfo pageInfo = goodsTracedUserService.searchTracedUserByPage(tracedUserForm);
        return success(pageInfo.getList(),pageInfo.getTotal());
    }
}
