package com.hcloud.microservice.goods.dao;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microserver.commoncore.base.PageBean;
import com.hcloud.microservice.goods.facade.entity.GoodsDealer;
import com.hcloud.microservice.goods.facade.forms.GoodsDealerForm;

public interface GoodsDealerMapper extends BaseMapper<GoodsDealer, String>{
	
	/**
	 * 分页查询
	 * @author lym
	 * @param goodsDealerForm
	 * @return
	 */
	List<GoodsDealer> searchByPage(PageBean<GoodsDealerForm> pageBean);
	
	/**
	 * 获取最大编码
	 * @author lym
	 * @param orgGuid
	 * @return
	 */
	String getMaxCode();
	
	/**
     * 查询企业所有经销商
     * @author lym
     * @param orgGuid
     * @return
     */
	List<GoodsDealer> selectList(@Param("orgGuid") String orgGuid);
	
	/**
	 * 编码是否存在
	 * @author lym
	 * @param code
	 * @return
	 */
	int existCode(@Param("code") String code);
}