package com.hcloud.microservice.goods.dao;

import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microserver.commoncore.base.PageBean;
import com.hcloud.microservice.goods.facade.entity.GoodsProNormal;
import com.hcloud.microservice.goods.facade.forms.GoodsProNormalForm;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author JYJ
 */
public interface GoodsProNormalMapper extends BaseMapper<GoodsProNormal,String> {
    /**
     * 分页查询通用流通信息
     * @param pageBean
     * @return
     */
    List<GoodsProNormal> searchProNormalByPage(PageBean<GoodsProNormalForm> pageBean);

    /**
     * 批量插入生产过程信息
     * @param list
     * @return
     */
    int batchSaveProNormal(List<GoodsProNormal> list);

    /**
     * 通过商品批次号查询生产过程信息
     * @param batchId
     * @param processType
     * @return
     */
    List<GoodsProNormal> searchProNormalByFK(@Param("batid") String batchId,@Param("type") Integer processType);

    /**
     * 删除加工生产过程信息
     * @param batchId
     * @return
     */
    int delProNormalByFK(@Param("batid") String batchId);
}