package com.hcloud.microservice.goods.dao;


import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microservice.goods.bo.GoodsQRCodeInfoBO;
import com.hcloud.microservice.goods.facade.entity.GoodsQRCodeInfo;
import com.hcloud.microservice.goods.facade.forms.GoodsQRCodeInfoForm;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author apple
 */
public interface GoodsQRCodeInfoMapper extends BaseMapper<GoodsQRCodeInfo,String> {
    /**
     * 通过生成记录ID查询溯源码记录
     * @param recodeId
     * @return
     */
    List<GoodsQRCodeInfoBO> queryGoodsQRCodeInfoByRecId(@Param("recodeId") String recodeId);

    /**
     * 通过扫码识别token查询
     * @param qrToken
     * @return
     */
    GoodsQRCodeInfoBO getGoodsQRInfoByQrToken(@Param("qrToken") String qrToken);

    /**
     * 批量添加溯源码信息记录
     * @param list
     * @return
     */
    int batchSaveQRCodeInfo(List<GoodsQRCodeInfo> list);

    /**
     * 更新溯源码信息通过生成记录Id
     * @param goodsQRCodeInfo
     * @return
     */
    int updateGoodsQRCodeInfoByRecord(GoodsQRCodeInfo goodsQRCodeInfo);

    /**
     * 删除溯源码明细信息
     * @param recordId
     * @return
     */
    int delQRCodeInfoByRecordId(@Param("recordId") String recordId);

    /**
     * 批量更新溯源码信息通过生成记录Id
     * @param list
     * @return
     */
    int batchUpdateGoodsQRCodeInfoByRecord(List<String> list);
    
    /**
     * 通过生成记录Id查询打印溯源码信息
     * @author lym
     * @param qrToken
     * @return
     */
    List<GoodsQRCodeInfoBO> getPrintGoodsQRInfo(GoodsQRCodeInfoForm goodsQRCodeInfoForm);
    
    /**
     * 修改是否打印状态
     * @author lym
     * @param ids
     * @return
     */
    int updateQRIsPrint(@Param("ids") List<String> ids);
}