package com.hcloud.microservice.goods.service;

import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microservice.goods.facade.entity.GoodsAssayInfo;
import com.hcloud.microservice.goods.facade.forms.GoodsAssayInfoForm;

/**
 * 商品批次检疫信息
 * @author xiezt
 */
public interface GoodsAssayInfoService extends BaseServie<GoodsAssayInfo,String> {
    /**
     * 保存商品批次检疫检验信息
     * @param goodsAssayInfoForm
     * @return
     */
    int saveBatchGoodsAssayInfo(GoodsAssayInfoForm goodsAssayInfoForm);

    /**
     * 通过商品批次id查询商品批次检疫检验信息
     * @param batchId
     * @return
     */
    GoodsAssayInfoForm searchByGoodsBatchId(String batchId);

    /**
     * 编辑商品批次检验信息
     * @param goodsAssayInfoForm
     * @return
     */
    int editBatchGoodsAssayInfo(GoodsAssayInfoForm goodsAssayInfoForm);

    /**
     * 删除商品批次检验信息
     * @param guid
     * @param orgGuid
     * @return
     */
    int delBatchGoodsAssayInfo(String guid,String orgGuid);

    /**
     * 删除商品批次检验信息通过商品批次ID
     * @param batchId
     * @return
     */
    int delBatchGoodsAssayInfoByBatchId(String batchId);
}
