package com.hcloud.microservice.goods.service;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microservice.goods.facade.entity.GoodsField;
import com.hcloud.microservice.goods.facade.forms.GoodsFieldForm;

/**
 * 产品产地服务
 * @author xiezt
 */
public interface GoodsFieldService extends BaseServie<GoodsField,String> {

    /**
     * 分页查询产地信息
     * @param goodsFieldForm
     * @return
     */
    PageInfo searchGoodsFieldByPage(GoodsFieldForm goodsFieldForm);

    /**
     * 添加商品产地
     * @param goodsFieldForm
     * @return
     */
    int addGoodsFieldInfo(GoodsFieldForm goodsFieldForm);

    /**
     * 修改商品产地
     * @param goodsFieldForm
     * @return
     */
    int updateGoodsFieldInfo(GoodsFieldForm goodsFieldForm);


    /**
     * 查询产地明细
     * @param goodsId
     * @param orgGuid
     * @return
     */
    GoodsFieldForm getGoodsFieldInfoById(String goodsId,String orgGuid);
}
