package com.hcloud.microservice.goods.service;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microservice.goods.facade.forms.GoodsProInputsForm;

import java.util.List;

/**
 * @author JYJ
 */
public interface GoodsProInputsService extends BaseServie<GoodsProInputsForm,String> {

    /**
     * 分页查询投入品信息
     * @param inputsForm
     * @return
     */
    PageInfo searchProInputsByPage(GoodsProInputsForm inputsForm);

    /**
     *  查询投入品信息通过商品批次GUID
     * @param batchGuid
     * @return
     */
    List<GoodsProInputsForm> searchProInputsByBatchGuid(String batchGuid);

    /**
     * 批量保存生产原料信息
     * @param list
     * @return
     */
    int batchSaveProInputs(List<GoodsProInputsForm> list);

    /**
     * 删除原料投入品信息
     * @param batchGuid
     * @return
     */
    int delProInputs(String batchGuid);
}
