package com.hcloud.microservice.goods.service;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microserver.commoncore.base.PageBean;
import com.hcloud.microservice.goods.facade.entity.GoodsQRCodeInfo;
import com.hcloud.microservice.goods.facade.forms.GoodsQRCodeInfoForm;

import java.util.List;

/**
 * 二维码基本信息
 * @author xiezt
 */
public interface GoodsQRCodeInfoService extends BaseServie<GoodsQRCodeInfo,String> {
    /**
     * 通过扫码更新溯源码信息
     * @param qrToken
     * @return
     */
    int updateGoodsQRInfoByScan(String qrToken);

    /**
     * 通过溯源传输码查询溯源码信息
     * @param qrToken
     * @return
     */
    GoodsQRCodeInfoForm getGoodsQRInfo(String qrToken);

    /**
     * 批量保存溯源码信息
     * @param codeInfoForm
     * @return
     */
    int batchSaveGoodsQRCodeInfo(GoodsQRCodeInfoForm codeInfoForm);

    /**
     * 通过溯源码生成记录Id查询溯源码信息
     * @param goodsQRCodeInfoForm
     * @return
     */
    PageInfo queryGoodsQRCodeInfoByRecId(GoodsQRCodeInfoForm goodsQRCodeInfoForm);

    /**
     * 删除溯源明细信息（逻辑删除）
     * @param goodsQRCodeInfoForm
     * @return
     */
    int delGoodsQRCodeInfoByRecordId(GoodsQRCodeInfoForm goodsQRCodeInfoForm);

    /**
     * 删除溯源明细信息（物理删除）
     * @param recordId
     * @return
     */
    int delQRCodeInfoByPhysical(String recordId);

    /**
     * 废弃单个溯源码信息（逻辑删除）
     * @param goodsQRCodeInfoForm
     * @return
     */
    int forbiddenCodeInfoByCodeId(GoodsQRCodeInfoForm goodsQRCodeInfoForm);

    /**
     * 批量更新溯源码信息通过生成记录Id
     * @param list
     * @return
     */
    int batchUpdateGoodsQRCodeInfoByRecord(List<String> list);
    
    /**
     * 通过生成记录Id查询打印溯源码信息
     * @author lym
     * @param recordId
     * @return
     */
    PageInfo getPrintGoodsQRInfo(GoodsQRCodeInfoForm goodsQRCodeInfoForm);
    
    /**
     * 修改是否打印状态
     * @author lym
     * @param ids
     * @return
     */
    int updateQRIsPrint(List<String> ids);
}
