package com.hcloud.microservice.goods.service.impl;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.PageBean;
import com.hcloud.microserver.commoncore.util.CodeUtil;
import com.hcloud.microserver.commoncore.util.GetUUID;
import com.hcloud.microservice.goods.dao.GoodsDealerMapper;
import com.hcloud.microservice.goods.facade.entity.GoodsDealer;
import com.hcloud.microservice.goods.facade.forms.GoodsDealerForm;
import com.hcloud.microservice.goods.service.GoodsDealerService;

@Service
public class GoodsDealerServiceImpl implements GoodsDealerService{
	
	private static final Integer POSITION_HEAD_LENGTH=6;

    private static final Integer POSITION_LEVEL_STEP=3;
	
	@Resource
	GoodsDealerMapper goodsDealerMapper;

	@Override
	public int delByPrimaryKey(String guid) {
		// TODO Auto-generated method stub
		return goodsDealerMapper.deleteByPrimaryKey(guid);
	}

	@Override
	public int save(GoodsDealer record) {
		// TODO Auto-generated method stub
		return saveSelective(record);
	}

	@Override
	public int saveSelective(GoodsDealer record) {
		record.setGuid(GetUUID.getUUID());
		if(goodsDealerMapper.existCode(record.getDealerCode()) > 0) {
			record.setDealerCode(getMaxCode());
		}
		return goodsDealerMapper.insertSelective(record);
	}

	@Override
	public GoodsDealer queryByPrimaryKey(String guid) {
		// TODO Auto-generated method stub
		GoodsDealer dealer = goodsDealerMapper.selectByPrimaryKey(guid);
		//处理地址信息
		dealPositionInfo(dealer);
		return dealer;
	}

	@Override
	public int modifyByPrimaryKeySelective(GoodsDealer record) {
		// TODO Auto-generated method stub
		return goodsDealerMapper.updateByPrimaryKeySelective(record);
	}

	@Override
	public int modifyByPrimaryKeyWithBLOBs(GoodsDealer record) {
		// TODO Auto-generated method stub
		return goodsDealerMapper.updateByPrimaryKeyWithBLOBs(record);
	}

	@Override
	public int modifyByPrimaryKey(GoodsDealer record) {
		// TODO Auto-generated method stub
		return goodsDealerMapper.updateByPrimaryKey(record);
	}

	@Override
	public PageInfo searchByPage(GoodsDealerForm goodsDealerForm) {
		PageBean pageBean = new PageBean(goodsDealerForm);
		PageHelper.startPage(goodsDealerForm.getPageNo(), goodsDealerForm.getPageSize());
		List<GoodsDealer> list = goodsDealerMapper.searchByPage(pageBean);
		return new PageInfo<>(list);
	}

	@Override
	public String getMaxCode() {
		String maxCode = goodsDealerMapper.getMaxCode();
		String newCode = "JXS00001";
		if(maxCode != null) {
			newCode = CodeUtil.getNextCode(maxCode, "JXS", 5);
		}
				
		return newCode;
	}

	@Override
	public List<GoodsDealer> selectList(String orgGuid) {
		// TODO Auto-generated method stub
		return goodsDealerMapper.selectList(orgGuid);
	}
	
	private void dealPositionInfo(GoodsDealer dealer){
		String positionId = dealer.getFkPostionId();
        if(null!= positionId && !"".equals(positionId)){
            int nextLen =0;
            int totalLen = positionId.length();
            String provinceId = positionId.substring(0,POSITION_HEAD_LENGTH);
            dealer.setProvinceId(provinceId);
            int currentLen = totalLen-POSITION_HEAD_LENGTH;
            if(currentLen>=POSITION_LEVEL_STEP){
                nextLen = POSITION_HEAD_LENGTH+POSITION_LEVEL_STEP;
                String cityId = positionId.substring(0,nextLen);
                dealer.setCityId(cityId);
                currentLen = totalLen-cityId.length();
                if(currentLen>=POSITION_LEVEL_STEP){
                    nextLen = cityId.length()+POSITION_LEVEL_STEP;
                    String countyId = positionId.substring(0,nextLen);
                    dealer.setCountyId(countyId);
                }
            }
        }

    }

}
