package com.hcloud.microservice.goods.service.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.PageBean;
import com.hcloud.microserver.commoncore.util.BeanCopyUtil;
import com.hcloud.microserver.commoncore.util.UUIDUtils;
import com.hcloud.microservice.goods.dao.GoodsProNormalMapper;
import com.hcloud.microservice.goods.facade.entity.GoodsProNormal;
import com.hcloud.microservice.goods.facade.forms.GoodsProNormalForm;
import com.hcloud.microservice.goods.service.GoodsProNormalService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author JYJ
 */
@Service("goodProNormalService")
public class GoodsProNormalServiceImpl implements GoodsProNormalService {


    @Resource
    private GoodsProNormalMapper goodsProNormalMapper;

    @Override
    public int delByPrimaryKey(String guid) {
        return goodsProNormalMapper.deleteByPrimaryKey(guid);
    }

    @Override
    public int save(GoodsProNormalForm record) {
        GoodsProNormal goodsProNormal = new GoodsProNormal();
        BeanCopyUtil.copyBean(record,goodsProNormal);
        goodsProNormal.setGuid(UUIDUtils.randomUUID());
        return goodsProNormalMapper.insert(goodsProNormal);
    }

    @Override
    public int saveSelective(GoodsProNormalForm record) {
        GoodsProNormal goodsProNormal = new GoodsProNormal();
        BeanCopyUtil.copyBean(record,goodsProNormal);
        goodsProNormal.setGuid(UUIDUtils.randomUUID());
        return goodsProNormalMapper.insertSelective(goodsProNormal);
    }

    @Override
    public GoodsProNormalForm queryByPrimaryKey(String guid) {
        GoodsProNormalForm record = new GoodsProNormalForm();
        GoodsProNormal goodsProNormal = goodsProNormalMapper.selectByPrimaryKey(guid);
        BeanCopyUtil.copyBean(goodsProNormal,record);
        return record;
    }

    @Override
    public int modifyByPrimaryKeySelective(GoodsProNormalForm record) {
        GoodsProNormal goodsProNormal = new GoodsProNormal();
        BeanCopyUtil.copyBean(record,goodsProNormal);
        return goodsProNormalMapper.updateByPrimaryKeySelective(goodsProNormal);
    }

    @Override
    public int modifyByPrimaryKeyWithBLOBs(GoodsProNormalForm record) {
        //TODO empty implements
        return 0;
    }

    @Override
    public int modifyByPrimaryKey(GoodsProNormalForm record) {
        GoodsProNormal goodsProNormal = new GoodsProNormal();
        BeanCopyUtil.copyBean(record,goodsProNormal);
        return goodsProNormalMapper.updateByPrimaryKey(goodsProNormal);
    }

    /**
     * 分页查询通用流通信息
     *
     * @param goodsProNormalForm
     * @return
     */
    @Override
    public PageInfo searchProNormalByPage(GoodsProNormalForm goodsProNormalForm) {
        PageHelper.startPage(goodsProNormalForm.getPageNo(),goodsProNormalForm.getPageSize());
        List<GoodsProNormal> resultList = goodsProNormalMapper.searchProNormalByPage(new PageBean<>(goodsProNormalForm));
        return new PageInfo(resultList);
    }

    /**
     * 批量保存生产过程信息
     *
     * @param list
     * @return
     */
    @Override
    public int batchSaveProNormal(List<GoodsProNormalForm> list) {
        if(null!=list && list.size()>0){
            List<GoodsProNormal> resultList = BeanCopyUtil.convertList(list,GoodsProNormal.class);
            for (GoodsProNormal bean:resultList) {
                String processAddress = bean.getProcessAddress();
                String processImgs = bean.getProcessImgs();
                bean.setProcessAddress(processAddress==null ? "":processAddress);
                bean.setProcessImgs(processImgs==null ? "":processImgs);
            }
           return goodsProNormalMapper.batchSaveProNormal(resultList);
        }
        return 0;
    }

    /**
     * 通过商品批次号查询生产过程信息
     *
     * @param batchId
     * @return
     */
    @Override
    public List<GoodsProNormalForm> searchProNormalByFK(String batchId,Integer processType) {
       List<GoodsProNormal> resultList =  goodsProNormalMapper.searchProNormalByFK(batchId,processType);
       if(null!=resultList && resultList.size()>0){
            return BeanCopyUtil.convertList(resultList,GoodsProNormalForm.class);
       }
       return null;
    }

    /**
     * 删除加工生产过程信息
     *
     * @param batchId
     * @return
     */
    @Override
    public int delProNormalByFK(String batchId) {
        return goodsProNormalMapper.delProNormalByFK(batchId);
    }
}
