package com.hcloud.microservice.goods.service.impl;

import com.hcloud.microservice.goods.facade.forms.GoodsQRCodeRecordStatForm;
import com.hcloud.microservice.goods.facade.results.ScanNumStatResult;
import com.hcloud.microservice.goods.service.GoodsQRCodeRecordStatService;
import lombok.extern.slf4j.Slf4j;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.List;

@Slf4j
@RunWith(SpringRunner.class)
@SpringBootTest
public class GoodsQRCodeRecordStatServiceImplTest {

    @Autowired
    private GoodsQRCodeRecordStatService goodsQRCodeRecordStatService;

    @Test
    public void testStatOneYearAllMonthData() {
        GoodsQRCodeRecordStatForm goodsQRCodeRecordStatForm = new GoodsQRCodeRecordStatForm();
        goodsQRCodeRecordStatForm.setFkOrgGuid("79c0f0a56d044d8a9b712c1c454e648f");
        goodsQRCodeRecordStatForm.setYear(2019);
        ScanNumStatResult result = null;//this.goodsQRCodeRecordStatService.statOneYearAllMonthData(goodsQRCodeRecordStatForm);
        log.info("数据: {}", result);
        Assert.assertNotNull(result);
    }

    @Test
    public void testStatYesterdayAndAllTimeScanNumber() {
        GoodsQRCodeRecordStatForm goodsQRCodeRecordStatForm = new GoodsQRCodeRecordStatForm();
        goodsQRCodeRecordStatForm.setFkOrgGuid("79c0f0a56d044d8a9b712c1c454e648f");
        List<ScanNumStatResult> results = this.goodsQRCodeRecordStatService.statYesterdayAndAllTimeData(goodsQRCodeRecordStatForm);
        log.info("数据: {}", results);
        Assert.assertNotNull(results);
    }

    @Test
    public void testStatTodayScanNumber() {
        GoodsQRCodeRecordStatForm goodsQRCodeRecordStatForm = new GoodsQRCodeRecordStatForm();
        goodsQRCodeRecordStatForm.setFkOrgGuid("79c0f0a56d044d8a9b712c1c454e648f");
        List<ScanNumStatResult> results = this.goodsQRCodeRecordStatService.statOneDayAllHoursData(goodsQRCodeRecordStatForm);

        for (ScanNumStatResult result : results) {
            log.info("整点: {} ----- 扫描人数: {}", result.getHour(), result.getScanNum());
        }

        Assert.assertNotNull(results);
    }

    @Test
    public void testStatOneWeekSevenDays() {
        GoodsQRCodeRecordStatForm goodsQRCodeRecordStatForm = new GoodsQRCodeRecordStatForm();
        goodsQRCodeRecordStatForm.setFkOrgGuid("79c0f0a56d044d8a9b712c1c454e648f");
        List<ScanNumStatResult> results = this.goodsQRCodeRecordStatService.statOneWeekSevenDaysData(goodsQRCodeRecordStatForm);

        for (ScanNumStatResult result : results) {
            log.info("星期{}: ----- 扫描人数: {}", result.getDayOfWeek(), result.getScanNum());
        }

        Assert.assertNotNull(results);
    }

    @Test
    public void testStatOneMonthAllDays() {
        GoodsQRCodeRecordStatForm goodsQRCodeRecordStatForm = new GoodsQRCodeRecordStatForm();
        goodsQRCodeRecordStatForm.setFkOrgGuid("79c0f0a56d044d8a9b712c1c454e648f");
        List<ScanNumStatResult> results = this.goodsQRCodeRecordStatService.statOneMonthAllDaysData(goodsQRCodeRecordStatForm);
        for (ScanNumStatResult result : results) {
            log.info("{}号: ----- 扫描人数: {}", result.getDayOfMonth(), result.getScanNum());
        }
        Assert.assertNotNull(results);
    }
}
